<?php
class ControllerPaymentCheckoutFi extends Controller {

	private $name = '';
	protected $errors = array();
	
	protected function index() {
		
		$classname = str_replace('vq2-catalog_controller_payment_', '', basename(__FILE__, '.php'));
    	$this->data = array_merge($this->data, $this->load->language('payment/' . $classname));

		$this->data['action'] = 'https://payment.checkout.fi/';
		
		$this->data['error'] = (isset($this->session->data['error'])) ? $this->session->data['error'] : NULL;
		unset($this->session->data['error']);
		
		$this->load->model('checkout/order');
		
		$order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);
		// v14x Backwards Compatibility
		if (isset($order_info['currency_code'])) { $order_info['currency'] = $order_info['currency_code']; }
		if (isset($order_info['currency_value'])) { $order_info['value'] = $order_info['currency_value']; }
			
		$merchant_id = $this->config->get($classname . '_mid');
		$amount = 100 * $this->currency->format($order_info['total'], $order_info['currency'], $order_info['value'], FALSE);
		$currency = '978';
		
		$version="0001";
		$stamp=time();
		$reference=$this->session->data['order_id'];
		$message=$this->session->data['order_id'];
		//$language=strtoupper((in_array($this->config->get('config_language')), array('fi', 'en', 'se'))) ? $this->config->get('config_language') : 'FI'); // FI, EN, SE
		$language="FI"; // FI, EN, SE
		$merchant=$this->config->get($classname . '_mid');
		$password=$this->config->get($classname . '_key');
		$return=(((HTTPS_SERVER) ? HTTPS_SERVER : HTTP_SERVER) . 'index.php?route=payment/' . $classname . '/callback&method=return');
		$cancel=(((HTTPS_SERVER) ? HTTPS_SERVER : HTTP_SERVER) . 'index.php?route=payment/' . $classname . '/callback&method=cancel');
		$reject=(((HTTPS_SERVER) ? HTTPS_SERVER : HTTP_SERVER) . 'index.php?route=payment/' . $classname . '/callback&method=reject');
		$delayed=(((HTTPS_SERVER) ? HTTPS_SERVER : HTTP_SERVER) . 'index.php?route=payment/' . $classname . '/callback&method=delayed');
		$country=$order_info['payment_iso_code_3'];
		$currency="EUR";
		$device="1";
		$content="1";
		$type="0";
		$algorithm="1";
		$delivery_date=date("Ymd");
		$firstname=html_entity_decode($order_info['payment_firstname'], ENT_QUOTES, 'UTF-8');
		$familyname=html_entity_decode($order_info['payment_lastname'], ENT_QUOTES, 'UTF-8');
		$address=html_entity_decode($order_info['payment_address_1'], ENT_QUOTES, 'UTF-8') . ' ' . html_entity_decode($order_info['payment_address_2'], ENT_QUOTES, 'UTF-8');
		$postcode=html_entity_decode($order_info['payment_postcode'], ENT_QUOTES, 'UTF-8');
		$postoffice=html_entity_decode($order_info['payment_city'], ENT_QUOTES, 'UTF-8');

		$line="$version+$stamp+$amount+$reference+$message+$language+$merchant+" . html_entity_decode($return) . "+" . html_entity_decode($cancel) . "+" . html_entity_decode($reject) . "+" . html_entity_decode($delayed) . "+$country+$currency+$device+$content+$type+$algorithm+$delivery_date+$firstname+$familyname+$address+$postcode+$postoffice+$password";

		$mac=strtoupper(md5($line));

		
		$this->data['fields'] = array();
		$this->data['fields']['VERSION']= $version;
		$this->data['fields']['STAMP']= $stamp;
		$this->data['fields']['AMOUNT']= $amount;
		$this->data['fields']['REFERENCE'] = $reference;
		$this->data['fields']['MESSAGE']= $message;
		$this->data['fields']['LANGUAGE']= $language;
		$this->data['fields']['MERCHANT']= $merchant;
		$this->data['fields']['RETURN']= $return;
		$this->data['fields']['CANCEL']= $cancel;
		$this->data['fields']['REJECT']= $reject;
		$this->data['fields']['DELAYED']= $delayed;
		$this->data['fields']['COUNTRY']= $country;
		$this->data['fields']['CURRENCY'] = $currency;
		$this->data['fields']['DEVICE']= $device;
		$this->data['fields']['CONTENT']= $content;
		$this->data['fields']['TYPE']= $type;
		$this->data['fields']['ALGORITHM']= $algorithm;
		$this->data['fields']['DELIVERY_DATE']= $delivery_date;
		$this->data['fields']['FIRSTNAME']= $firstname;
		$this->data['fields']['FAMILYNAME']= $familyname;
		$this->data['fields']['ADDRESS']= $address;
		$this->data['fields']['POSTCODE']= $postcode;
		$this->data['fields']['POSTOFFICE']= $postoffice;
		$this->data['fields']['MAC']= $mac;
		$this->data['fields']['Checkout'] = 'Checkout';
				
		if (method_exists($this->document, 'addBreadcrumb')) { //1.4.x
			$this->data['back'] = (((HTTPS_SERVER) ? HTTPS_SERVER : HTTP_SERVER) . 'index.php?route=checkout/payment');
		} else {
			$this->data['back'] = (((HTTPS_SERVER) ? HTTPS_SERVER : HTTP_SERVER) . 'index.php?route=checkout/checkout');
		}
		$this->id       = 'payment';

		//$this->template = $this->config->get('config_template') . 'payment/' . $classname . '.tpl';
		if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/payment/' . $classname . '.tpl')) {
            $this->template = $this->config->get('config_template') . '/template/payment/' . $classname . '.tpl';
        } else {
            $this->template = 'default/template/payment/' . $classname . '.tpl';
        }
		$this->render();		
	}
	
	public function confirm() {
		$classname = str_replace('vq2-catalog_controller_payment_', '', basename(__FILE__, '.php'));
		if ($this->config->get($classname . '_ajax')) {
			$this->load->model('checkout/order');
			$this->model_checkout_order->confirm($this->session->data['order_id'], $this->config->get('config_order_status_id'));
		}
	}
		
	private function fail($msg = false) {
		$store_url = ($this->config->get('config_ssl') && !is_numeric($this->config->get('config_ssl'))) ? $this->config->get('config_ssl') : ((HTTPS_SERVER)?HTTPS_SERVER:HTTP_SERVER);
		if (!$msg) { $msg = (!empty($this->session->data['error']) ? $this->session->data['error'] : 'Unknown Error'); }
		if (method_exists($this->document, 'addBreadcrumb')) { //1.4.x
			$this->redirect((isset($this->session->data['guest'])) ? (((HTTPS_SERVER) ? HTTPS_SERVER : HTTP_SERVER) . 'index.php?route=checkout/guest_step_3') : (((HTTPS_SERVER) ? HTTPS_SERVER : HTTP_SERVER) . 'index.php?route=checkout/confirm'));
		} else {
			echo '<html><head><script type="text/javascript">';
			echo 'alert("'.$msg.'");';
			echo 'window.location="' . ($store_url  . 'index.php?route=checkout/checkout') . '";';
			echo '</script></head></html>';
		}
		exit;
	}

	public function callback() {
		$classname = str_replace('vq2-catalog_controller_payment_', '', basename(__FILE__, '.php'));
		
		// Debug
		if ($this->config->get($classname . '_debug')) { file_put_contents(DIR_LOGS . $classname . '_debug.txt', "CALLBACK GET: " . print_r($_GET,1) . "\r\n CALLBACK POST: " . print_r($_POST,1) . "\r\n"); }
		
		if ($this->request->get['method'] == 'cancel') {

			$this->redirect((((HTTPS_SERVER) ? HTTPS_SERVER : HTTP_SERVER) . 'index.php?route=checkout/checkout'));

//			$this->redirect((((HTTPS_SERVER) ? HTTPS_SERVER : HTTP_SERVER) . 'index.php?route=checkout/payment'));
		} elseif ($this->request->get['method'] == 'reject') {
			$this->session->data['error'] = $this->language->get('error_reject');
			$this->fail();
		}
		
		$this->data = array_merge($this->data, $this->load->language('payment/' . $classname));
		
		$this->load->model('checkout/order');
		
		$order_id = $this->request->get['REFERENCE'];
		
		$order_info = $this->model_checkout_order->getOrder($order_id);
		
		// If there is no order info then fail.
		if (!$order_info) {
			$this->session->data['error'] = $this->language->get('error_no_order');
			$this->fail();
		}
		
		// Ajax Callback and HTTP Return both call the confirm step, so only process once by checking the confirm status.
		if ($order_info['order_status_id'] == 0) {
			if ($this->request->get['method'] == 'return') {
				$this->model_checkout_order->confirm($order_info['order_id'], $this->config->get($classname . '_order_status_id'));
			} else { // delayed goes to pending as its not ready yet.
				$this->model_checkout_order->confirm($order_info['order_id'], $this->config->get('config_order_status_id'));
			}
		}
			
		// Since it returned, the customer should see success.
		// It's up to the store owner to manually verify pending payments.
		$this->redirect((((HTTPS_SERVER) ? HTTPS_SERVER : HTTP_SERVER) . 'index.php?route=checkout/success'));
	}
}
?>
